-------------------------------
-- Created by Tinuviel, cpc197c@gmail.com
--
-- Created under the Creative Commons CC BY-NC license. This license allows for 
-- copying, redistributing, modifying, and building upon as long as this license
-- follows all derivative works and attributes the original author(s)
--     See https://creativecommons.org/licenses/by-nc/4.0/ for more information.
-------------------------------

-- Handles setting set/get and defaults

EF_Settings = {}

EF_Settings.Default =
{
    IsManualOverride = false
}
EF_Settings.Default.MonitorWidth, EF_Settings.Default.BezelCorrection, EF_Settings.Default.BezelSize = EF_Utilities.GetMonitorWidth()

EF_Settings.EnsureSavedVariablesLoaded = function()
    if (Eyefinity.Settings ~= nil) then
        return
    end

    EF_Settings.Saved = ZO_SavedVars:New("EyefinitySupportDB", 2, "Settings", {}, "EF") or {}
    if (not EF_Settings.Saved) then
        EF_Settings.Saved =
        {
            IsManualOverride = false,
            BezelSize = bezelSize
        }
    end
end

EF_Settings.GetSetting = function(settingName)
    local value = WF_GetOrDefault(EF_Settings.Default[settingName], EF_Settings.Saved[settingName])
    EF_Utilities.WriteDebug("Getting setting - " .. settingName .. ": " .. tostring(value))
    return value
end

EF_Settings.SetSetting = function(settingName, value)
    local hasChanged = EF_Settings.Saved[settingName] ~= value
    if (hasChanged) then
        EF_Settings.Saved[settingName] = value
        EF_Utilities.WriteDebug("Setting " .. settingName .. " to - " .. ": " .. tostring(value))
    end

    return hasChanged
end