-------------------------------
-- Created by Tinuviel, cpc197c@gmail.com
--
-- Created under the Creative Commons CC BY-NC license. This license allows for 
-- copying, redistributing, modifying, and building upon as long as this license
-- follows all derivative works and attributes the original author(s)
--     See https://creativecommons.org/licenses/by-nc/4.0/ for more information.
-------------------------------

-- Registers the addon

-----------
-- Override AddCheckbox so I can hook adding the multimonitor setting
----------
local oldAddCheckbox = WF_SettingsMenu.AddCheckbox
WF_SettingsMenu.AddCheckbox = function(text, tooltip, getFunc, setFunc, warning, warningText, parentMenu)
    local newSetFunc = setFunc
    if text == "Enable Multi-Screen Support" or text == "|cB0B0FFNumber of Screens|r" or text == "|cB0B0FFTarget Screen|r" then
        newSetFunc = function(value)
            setFunc(value)
            Eyefinity.ToggleRegistration()
        end
    end

    if (text == "Enable Multi-Screen Support") then
        Eyefinity.ToggleRegistration()
    end

    oldAddCheckbox(text, tooltip, getFunc, newSetFunc, warning, warningText, parentMenu)
end

Eyefinity.OnStartup = function()
    WF_SettingsMenu.AddHeader("Eyefinity Settings")
    WF_SettingsMenu.AddCheckbox("Override Bezel Correction",
        "Allows the user to change the eyefinity/surround values if the auto calculation does not work correctly",
        function() return EF_Settings.GetSetting("IsManualOverride") end, Eyefinity.OnIsManualOverride)
    WF_SettingsMenu.AddEditBox("Bezel Width", "Sets the bezel width, must be used with 'Override Bezel Correction'", false,
        function() return EF_Settings.GetSetting("BezelSize") end, Eyefinity.OnSetBezelWidth)
end

Eyefinity.Ready, Eyefinity.AddonName, Eyefinity.AddonAbbrev, Eyefinity.AddonVersion, Eyefinity.AddonDescr = WF_RegisterFactory(
    Eyefinity.AddonID,
    {
        AddonID = Eyefinity.AddonID,
        AddonName = "[WF] Eyefinity Support",
        AddonAbbrev = "ef",
        Author = "Tinuviel",
        AddonVersion = "1.1",
        StartUp = Eyefinity.OnStartup,
        SavedVariables = EF_Settings.EnsureSavedVariablesLoaded
    }
)